diff --git a/drmemory/replace.c b/drmemory/replace.c
index 7b47daef3..fc0fb7d5b 100644
--- a/drmemory/replace.c
+++ b/drmemory/replace.c
@@ -682,7 +682,7 @@ replace_strstr(const char *haystack, const char *needle)
     if (*n == '\0')
         return (char *) haystack;
     while (*hs != '\0') {
-        if (*hs != *n) {
+        if (*hs != *n && n > needle) {
             hs -= n - 1 - needle; /* backtrack */
             n = needle;
         }
diff --git a/tests/app_suite/strmem_tests.cpp b/tests/app_suite/strmem_tests.cpp
index 2994c9b4d..3117985fa 100644
--- a/tests/app_suite/strmem_tests.cpp
+++ b/tests/app_suite/strmem_tests.cpp
@@ -110,6 +110,7 @@ TEST(StringTests, strstr) {
     ASSERT_STREQ(strstr("xxxA", "xxA"), "xxA");
     ASSERT_STREQ(strstr("PREFIXxxxxxASUFFIX", "xxxxA"), "xxxxASUFFIX");
     ASSERT_EQ(strstr("xxxAxABxxxA", "xxAB"), (char *)NULL);
+    ASSERT_EQ(strstr("xxx", "a"), (char *)NULL);
 
     /* Test i#1243 where msvcr100!strstr calls into the middle of strchr
      * and has an unaddr if the string doesn't fill out a malloc chunk
